#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xzf opendchub-0.7.15.tar.gz
    cd opendchub-0.7.15
    ./configure --prefix=/usr --sysconfdir=/etc --localstatedir=/var \
	    --enable-switch_user --disable-perl
    make
    rm src/opendchub
    make -C src opendchub LIBS="-lcrypt -L/usr/local/lib -Wl,-Bstatic -lcap \
	    -lcrypto -Wl,-Bdynamic"
    strip -R .note -R .comment src/opendchub
    mkdir -p ../opendchub/sbin
    cp src/opendchub ../opendchub/sbin/
    cd ..
    rm -rf opendchub-0.7.15
}

chmod 0600 opendchub/etc/opendchub/config

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
